function Exp01100_parametrosDeExpedicao_Controller (ScreenService,ZHPromise, templateManager, General, Exp01100_parametrosDeExpedicao_Service){
    
    this.adicionar = function(widget){
        var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        widget.newRow();
        widget.currentRow.__is_new = true;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        this.controlaStatusWidgets(tabbedParametrosExpedicao, widget.name, false);
        
    };
	
	this.editar = function(widget){
	    var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelar = function(widget){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        if(widget.currentRow.__is_new === true){    
            widget.parent.widgets.forEach(function(element){
                element.currentRow = {};
            });
        }
	    widget.template = widget.templateToView;
        widget.view();
        widget.reload();
        widget.activate();
        
        var tabbedParametrosExpedicao = templateManager.container.getWidget('tabbedParametrosExpedicao');
	    tabbedParametrosExpedicao.getField('NMFILIAL').readOnly = false;
	    
    };
    
    this.completeFieldVRPERCOMEXP = function(field){
       
       var VRPERCOMEXP = 100 - parseFloat(field.value().replace(/,/gi, "."));
       if(VRPERCOMEXP === 0){
          VRPERCOMEXP = 0; 
       }
         else if(VRPERCOMEXP > 0){
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = VRPERCOMEXP;    
       } else {
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = "";
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = "";
       }
       
    };
   
    this.completeFieldVRPERCOMREC = function(field){
       
       var VRPERCOMREC = 100 - parseFloat(field.value().replace(/,/gi, "."));
       if(VRPERCOMREC >= 0){
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = VRPERCOMREC;
       } else {
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMREC = "";
           templateManager.container.getWidget('informacoesFinanceiras').currentRow.VRPERCOMEXP = "";
       }
       
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });
    };
    
    this.filtroParametrosExpedicao = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        
        General.callRestEngine("ped_expedicao#/crud/parexpedicao_tipooperac","FilterData", filtro).then(function(sucesso){
            var resultado = sucesso.dataset.parexpedicao_tipooperac[0];
            widget.widgets.forEach(function(value){
                if(resultado && filial) {
                    value.currentRow = resultado;
                    value.getAction('editar').isVisible = true;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }else if(!resultado && filial){
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = true;
                    value.reload();
                }
                else {
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }
            });
            
        }.bind(this), function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.recarregarField = function(nomeWidget,nomeField){
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        field.reload();
    };
   
    this.saveLogExpedicao = function(widget){
        if(widget.isValid()){
            var promiseDel = [];
            var promiseIns = [];
            
            var nmgrupopersep = widget.currentRow.NMGRUPOPERSEP;
            var nmgrupopercon = widget.currentRow.NMGRUPOPERCON;
            
            // widget.currentRow.CDGRUPOPERSEP = (widget.currentRow.NMGRUPOPERSEP) ? widget.currentRow.CDGRUPOPERSEP : null; 
            
            if(nmgrupopersep){
                var objDelSep = {
                    "CDFILIAL": widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP": "LOGS"
                };
                promiseDel.push(Exp01100_parametrosDeExpedicao_Service.deleteLogExpedicao(objDelSep));
                
                var cdgrupopersep = widget.currentRow.CDGRUPOPERSEP;
                var objLog = {
                    "__is_new" : true,
                    "changed": true,
                    "CDFILIAL" : widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP" : 'LOGS',
                    "CDGRUPOPER": widget.currentRow.CDGRUPOPERSEP,
                    "NRAUTGRUPOP" : widget.currentRow.NRAUTGRUPOPSEP,
                    "NRORG" : widget.currentRow.NRORG
                };
                promiseIns.push(Exp01100_parametrosDeExpedicao_Service.insertLogExpedicao(objLog));
                
            }
            
            if(nmgrupopercon){
                var objDelConf = {
                    "CDFILIAL": widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP": "LOGC"
                };
                promiseDel.push(Exp01100_parametrosDeExpedicao_Service.deleteLogExpedicao(objDelConf));
                
                var cdgrupopercon = widget.currentRow.CDGRUPOPERCON;
                var objLogConf = {
                    "__is_new" : true,
                    "changed": true,
                    "CDFILIAL" : widget.currentRow.CDFILIAL,
                    "IDAUTGRUPOP" : 'LOGC',
                    "CDGRUPOPER": widget.currentRow.CDGRUPOPERCON,
                    "NRAUTGRUPOP" : widget.currentRow.NRAUTGRUPOPCON,
                    "NRORG" : widget.currentRow.NRORG
                };
                promiseIns.push(Exp01100_parametrosDeExpedicao_Service.insertLogExpedicao(objLogConf));
            }
            
            // if(nmgrupopersep || nmgrupopercon){
                ZHPromise.all(promiseDel).then(function(){
                    ZHPromise.all(promiseIns).then(function(){
                        General.saveCrud(widget).then(function() {
                            General.callRestEngine('ped#/crud/grupoper_autgrupop_logExpedicao/save', 'Row', widget.currentRow);
                        });
                    });
                });
            // }
            
            this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'controleLogExpedicao',true);
            var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
            tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
            var currentRow = widget.currentRow;
            if(currentRow.__is_new == true){
                this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
            }
            currentRow.__is_new = false;
            currentRow.changed = false;
            widget.template = widget.templateToView;
            widget.view();
            widget.list();
        }
    };
    
    this.reloadWidgets = function(){
        var widget = templateManager.container.getWidget('tabbedParametrosExpedicao');
        widget.widgets.forEach(function(element){
            element.reload();
        }.bind(this));
        templateManager.updateTemplate();
    };
    
    this.getMaxNrautgrupop = function(nomeWidget,nomeField){
        
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        var nrorg = field.widget.currentRow.NRORG;
        var cdgrupoper;
        var idautgrupop;
        
        if(field.name == 'NMGRUPOPERCON'){
            cdgrupoper = field.widget.currentRow.CDGRUPOPERCON;
            idautgrupop = 'LOGC';
        }
        else if(field.name == 'NMGRUPOPERSEP'){
            cdgrupoper = field.widget.currentRow.CDGRUPOPERSEP;
            idautgrupop = 'LOGS';
        }
        
        
        
        Exp01100_parametrosDeExpedicao_Service.getMaxNrautgrupop(cdgrupoper, idautgrupop, nrorg).then(function(retorno){
           var max = '0';
           var objeto = retorno.dataset.autgrupop;

            if(objeto[0]){
                objeto.forEach(function(obj){ 
                    if(obj.NRAUTGRUPOP > max){
                       max = obj.NRAUTGRUPOP;
                    }
                });
                max = parseInt(max) + 1;
            }else{
                max = '1';
            }
            
            if(field.name == 'NMGRUPOPERCON'){
                field.widget.currentRow.NRAUTGRUPOPCON = max;
                field.widget.currentRow.NRAUTGRUPOPSEP = (field.widget.currentRow.NRAUTGRUPOPSEP) ? field.widget.currentRow.NRAUTGRUPOPSEP : '1';
            }else if(field.name == 'NMGRUPOPERSEP'){
                field.widget.currentRow.NRAUTGRUPOPSEP = max;
                field.widget.currentRow.NRAUTGRUPOPCON = (field.widget.currentRow.NRAUTGRUPOPCON) ? field.widget.currentRow.NRAUTGRUPOPCON : '1';
            }
            
        });
    };
   
    this.salvarInformacoesFinanceiras = function(widget){
        var widgetInformacoesFinanceiras = templateManager.container.getWidget('informacoesFinanceiras');
        var calcula = widgetInformacoesFinanceiras.getField('IDCOMISPERIODO');
        
        if(calcula.value() == "S"){
            if((parseFloat(widget.getField('VRPERCOMEXP').value()) + parseFloat(widget.getField('VRPERCOMREC').value())) === 100){
            
            General.saveCrud(widget).then(function(sucesso){
                        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'informacoesFinanceiras',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
                    }.bind(this), function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
            }else{ 
               ScreenService.showMessage("A soma dos campos 'Percentual de Comissão na Expedição' e 'Percentual de Comissão na Baixa (Recebimento)' deve ser igual a 100%");
            }
       }else{
            General.saveCrud(widget).then(function(sucesso){
                        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'informacoesFinanceiras',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
       }
   };
   
    this.salvarDistribuicaoTransporte = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'distribuicaoTransporte',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarNotaFiscalEstoque = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'notaFiscalEstoque',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
    };
   
    this.salvarExpedicaoPorPedido = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorPedido',true);
                var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarExpPorItemPedido = function(widget){
        if(widget.isValid()){
            
            var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
            var campoPermissaoExpedicaoAdicional = expedicaoPorItemPedido.getField('IDPERADIEXP');
            var campoPercentual = expedicaoPorItemPedido.getField('VRPEADIEXP');
            if(campoPermissaoExpedicaoAdicional.value() == 'S'){
                if(campoPercentual.value() >= 0.01 && campoPercentual.value() <= 500){
                   General.saveCrud(widget).then(function(){
                       this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorItemPedido',true);
                            var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                            tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                            var currentRow = widget.currentRow;
                            widget.view();
                            if(currentRow.__is_new == true){
                                this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                            }
                            currentRow.__is_new = false;
                            currentRow.changed = false;
                            widget.template = widget.templateToView;
                            widget.getAction('editar').isVisible = true;
                            widget.getAction('atualizar').isVisible = true;
                            widget.getAction('novo').isVisible = false;
                        }.bind(this), function(callback){
                            if(callback.data){
                                ScreenService.showMessage(callback.data.error);
                            }
                        });
                
                }else{
                    ScreenService.showMessage("O valor do campo 'Percentual Máximo para Expedição Adicional' deve estar entre 0,01 e 500%");
                }
            }else{
                General.saveCrud(widget).then(function(sucesso){
                   this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'expedicaoPorItemPedido',true);
                        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
                        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
                        var currentRow = widget.currentRow;
                        widget.view();
                        if(currentRow.__is_new == true){
                            this.filtroParametrosExpedicao(tabbedParametrosExpedicao);
                        }
                        currentRow.__is_new = false;
                        currentRow.changed = false;
                        widget.template = widget.templateToView;
                        widget.getAction('editar').isVisible = true;
                        widget.getAction('atualizar').isVisible = true;
                        widget.getAction('novo').isVisible = false;
                    }.bind(this), function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
            }
        }
    };
    
    this.salvarContabilizacaoFrete = function(widget){
        General.saveCrud(widget);
        this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosExpedicao'),'contabilizacaoFretes',true);
        widget.enabled = true;
        var tabbedParametrosExpedicao =  templateManager.container.getWidget('tabbedParametrosExpedicao');
        tabbedParametrosExpedicao.getField('NMFILIAL').readOnly=false;
    };

    this.verificaPermissaoExpedAdicional = function(widget){
        var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
        var campoPermissaoExpedicaoAdicional= expedicaoPorItemPedido.getField('IDPERADIEXP');
        var campoPercentual =expedicaoPorItemPedido.getField('VRPEADIEXP');
        if(campoPermissaoExpedicaoAdicional.value()=="S"){
            campoPercentual.readOnly=false;
            campoPercentual.validations.required = true;
        }else {
            campoPercentual.setValue('0');
            campoPercentual.readOnly=true;
            campoPercentual.validations.required = false;
        }
    };
   
    this.verificaPercentualMaximo = function(widget){
        var expedicaoPorItemPedido =  templateManager.container.getWidget('expedicaoPorItemPedido');
        var campoPermissaoExpedicaoAdicional= expedicaoPorItemPedido.getField('IDPERADIEXP');
        if(campoPermissaoExpedicaoAdicional.value()=="S"){
           widget.getField('VRPEADIEXP').validations.range.required=true;
        }else{
            widget.getField('VRPEADIEXP').validations.range.required=false;
        }
   };
  
    this.verificaContaReceberFrete = function(){
        var widgetInformacoesFinanceiras =  templateManager.container.getWidget('informacoesFinanceiras');
        var campoGeraContaReceberFrete = widgetInformacoesFinanceiras.getField('IDGERACTFRETE');
        var campoPorcentagem = widgetInformacoesFinanceiras.getField('VRPERCFRETE');
        if(campoGeraContaReceberFrete.value()=="S"){
            campoPorcentagem.readOnly=false;
            campoPorcentagem.validations.required=true;
        }else {
            campoPorcentagem.setValue('0');
            campoPorcentagem.readOnly=true;
            campoPorcentagem.validations.required=false;
        }
    };
   
    this.verificaConferente = function(){
       var widgetControleLogExpedicao =  templateManager.container.getWidget('controleLogExpedicao');        
       var conferente = widgetControleLogExpedicao.getField('IDCONFERENTE');
       var grupoOp = widgetControleLogExpedicao.getField('NMGRUPOPERCON');
       if(conferente.value() == "1"){
           grupoOp.readOnly = true;
           grupoOp.setValue('');
           widgetControleLogExpedicao.currentRow.CDGRUPOPERCON = null;
           delete grupoOp.validations;
       }else{
           grupoOp.readOnly = false;
           grupoOp.validations = {required : true};
           
       }
    };
   
    this.verificaSeparador = function(){
       var widgetControleLogExpedicao =  templateManager.container.getWidget('controleLogExpedicao');        
       var separador = widgetControleLogExpedicao.getField('IDSEPARADOR');
       var grupoOp = widgetControleLogExpedicao.getField('NMGRUPOPERSEP');
       if(separador.value() == "1"){
           grupoOp.readOnly = true;
           grupoOp.setValue('');
           widgetControleLogExpedicao.currentRow.CDGRUPOPERSEP = null;
           delete grupoOp.validations;
       }else{
           grupoOp.readOnly = false;
           grupoOp.validations = {required : true};
       }
    };
   
    this.verificaComissao = function(){
       var widgetInformacoesFinanceiras = templateManager.container.getWidget('informacoesFinanceiras');
       var calcula = widgetInformacoesFinanceiras.getField('IDCOMISPERIODO');
       var expedicao = widgetInformacoesFinanceiras.getField('VRPERCOMEXP');
       var baixa = widgetInformacoesFinanceiras.getField('VRPERCOMREC');
       
       if(calcula.value() == "S"){
           expedicao.readOnly = false;
           expedicao.validations.required = true;
           baixa.readOnly = false;
           baixa.validations.required = true;
       }else{
           expedicao.readOnly = true;
           expedicao.validations.required = false;
           baixa.readOnly = true;
           baixa.validations.required = false;
           expedicao.setValue('0');
           baixa.setValue('0');
       }
    };
    
    this.changeEditLeitor = function(){
        var widget = templateManager.container.getWidget('expedicaoPorPedido');
        var idtpexppedido = widget.getField('IDTPEXPPEDIDO');
        var idexpleitor = widget.getField('IDEXPLEITOR');
        
        if(idtpexppedido.value() == 'COL'){
            idexpleitor.readOnly = false;
            idexpleitor.validations = {
                                        "required": true
                                    };
        }else{
            idexpleitor.readOnly = true;
            delete idexpleitor.validations;
            idexpleitor.setValue(null);
        }
    };
    
    this.changeEditRetiradaExpedicao = function(){
        var widget = templateManager.container.getWidget('notaFiscalEstoque');
        var idgerprodest = widget.getField('IDGERPRODEST');
        var idretproexp = widget.getField('IDRETPROEXP');
        
        if(idgerprodest.value() == '3'){
            idretproexp.readOnly = false;
        }else{
            idretproexp.readOnly = true;
        }
    };
    
    this.changeEditTrocaProduto = function(){
        var widget = templateManager.container.getWidget('notaFiscalEstoque');
        var idevolesttro = widget.getField('IDEVOLESTTRO');
        var nmgropertroc = widget.getField('NMGROPERTROC');
        
        if(idevolesttro.value() == 'N'){
            nmgropertroc.readOnly = false;
        }else{
            nmgropertroc.readOnly = true;
        }
    };
    
    this.changeEditGeraComissao = function(){
        var widget = templateManager.container.getWidget('informacoesFinanceiras');
        var idcomisperiodo = widget.getField('IDCOMISPERIODO');
        var vrpecogerexp = widget.getField('VRPECOGEREXP');
        
        if(idcomisperiodo.value() == 'S'){
            vrpecogerexp.readOnly = true;
            vrpecogerexp.setValue(null);
            delete vrpecogerexp.validations;
        }else{
            vrpecogerexp.readOnly = false;
            vrpecogerexp.validations = {
                                        "required": true
                                    };
        }
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp01100_parametrosDeExpedicao_Controller', Exp01100_parametrosDeExpedicao_Controller);
});