function Ped22000_relatorios_customizaveis_pedidos_itens_Controller (ScreenService, General, templateManager, ZhFilterPreferences) {
    
    this.setNameLayout = function(args){
        
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget) {
        
        var rowsToSet = {};
        var CDVENDEDOR_AUX ;

        this.getOperadorLogado().then(function(success) {
            
            var CDOPERADOR_AUX = success.dataset.operador[0].CDOPERADOR;
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                rowsToSet.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                
                rowsToSet.DTPEDIDO = this.getIntervaloDataFiltro();
              
              
                var filter = [
                    {
                        "name": "IDEXIBPEDIDO",
                        "operator": "=",
                        "value": "2"
                    },
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": "FILIAL_LOGADA"
                    }
                ];
        
                General.callRestEngine("ped#/crud/parampedido", 'FilterData', filter).then(function (success){
                    
                    if(success.dataset.parampedido.length != 0){
                        
                        var widget_aux = templateManager.container.getWidget('widgetRelatorioCustomizavelPedido');
                        widget_aux.getField('NMFANVEN').IDUTRELACVENDCLI_AUX = rowsToSet.IDUTRELACVENDCLI = success.dataset.parampedido[0].IDUTRELACVENDCLI;

                        var filterFilial = [
                            {
                                "name": "CDFILIAL",
                                "operator": "=",
                                "value": "FILIAL_LOGADA"
                            },
                            {
                                "name": "IDAUTGRUPOP",
                                "operator": "=",
                                "value": "TPED"
                            }
                            
                        ];
                        
                        General.callRestEngine("ped#/crud/autgrupop", 'FilterData', filterFilial).then(function (success){
                            
                            if(success.dataset.autgrupop.length != 0){
                                
                                var filterOperador = [
                                    {
                                        "name": "CDGRUPOPER",
                                        "operator": "=",
                                        "value": success.dataset.autgrupop[0].CDGRUPOPER
                                    },
                                    {
                                        "name": "CDOPERADOR",
                                        "operator": "=",
                                        "value": CDOPERADOR_AUX
                                    }
                                ];
                                
                                General.callRestEngine("ped#/crud/opergrupop", 'FilterData', filterOperador).then(function (success){
                                
                                    if(success.dataset.opergrupop.length != 0){
                                       
                                       
                                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function (){
                                           
                                            widget.container.getActiveWidget().getField('NMFANVEN').readOnly = false;
                                            widget.container.getActiveWidget().getField('NMFANVEN').readOnlyOnEdit = false;
                                            widget.container.getActiveWidget().currentRow.NMFANVEN = '';
                                            widget.container.getActiveWidget().currentRow.CDVENDEDOR = '';
                                       
                                       }.bind(this));
                                       

                                    }else{
                                        
                                        this.setVendedor(widget,rowsToSet);
                                        
                                    }
                                    
                                }.bind(this));
                                
                            }else{
                                
                                this.setVendedor(widget,rowsToSet);

                            }
                        
                            
                        }.bind(this));
                    
                        
                    }else{
                        
                        this.setVendedor(widget,rowsToSet);
                        
                    }
                     
                }.bind(this));
                
                
            }.bind(this));

        }.bind(this));
        
    };
    
    this.getIntervaloDataFiltro = function(){
        
        const startOfMonth = moment().startOf('month').format('DD/MM/YYYY');
        var today = moment().format('DD/MM/YYYY');
        
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : startOfMonth
        };
        
        return interval;
    };

    this.getOperadorLogado = function(){
        
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
	
    this.setCliente_Vendedor = function(widget,rowsToSet, CDVENDEDOR){
    
        var filterVendedor = [
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": templateManager.container.getActiveWidget().currentRow.CDVENDEDOR
            }
        ];
        
        General.callRestEngine("ped#/crud/cliente_vendedor", 'FilterData', filterVendedor).then(function (success){
            
            if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function () {
                    
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                    widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                    widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                    
                }.bind(this));

            }else{
                
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').dataSourceFilter = filterVendedor;
                widget.container.getActiveWidget().currentRow.NMRAZSOCCLIE = '';
                widget.container.getActiveWidget().getField('NMRAZSOCCLIE').reload();
                
            }
        
        }.bind(this));
        
    };
    
    this.setVendedor = function(widget, rowsToSet = {}){
       
        // var rowsToSet = {};
        this.getOperadorLogado().then(function(success) {
            
            var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": success.dataset.operador[0].CDOPERADOR
                }
            ];
            
            General.callRestEngine("ped#/crud/vendedor", 'FilterData', filter).then(function (success){
                
                if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){

                    templateManager.container.getActiveWidget().currentRow.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                    templateManager.container.getActiveWidget().currentRow.NMFANVEN = success.dataset.vendedor[0].NMFANVEN;
                
                }
                
                rowsToSet.CDVENDEDOR = success.dataset.vendedor[0].CDVENDEDOR;
                
                //verifica se o parametro de relação entre cliente_vendedor está ativo
                if(templateManager.container.getWidget('widgetRelatorioCustomizavelPedido').getField('NMFANVEN').IDUTRELACVENDCLI_AUX == 'S'){
                    
                    this.setCliente_Vendedor(widget,rowsToSet);

                }else{
                    
                    var clienteAtivo = [{
                        
                        "name": "IDCLIEATIV",
                        "operator": "=",
                        "value": "S"
                        
                    }];
                    

                    widget.getField('NMRAZSOCCLIE').dataSource.name = 'ped#/crud/cliente';
                    widget.getField('NMRAZSOCCLIE').dataSourceFilter = clienteAtivo;
                    widget.getField('NMRAZSOCCLIE').reload();
                    
                
                    if(templateManager.container.getActiveWidget().getField('NMFANVEN').readOnly){
                        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        
                    }
                    
                }
            
            }.bind(this));
            
        }.bind(this));
    };
   
    this.reloadDataSoure = function(args){
        args.owner.reload();
    };

    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
   
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ped22000_relatorios_customizaveis_pedidos_itens_Controller', Ped22000_relatorios_customizaveis_pedidos_itens_Controller);
});